#ifndef _mkdic_h_included_
#define _mkdic_h_included_

#include <stdio.h>
#include <anthy/xstr.h>

/** ñ */
struct word_entry {
  /** ʻ̾ */
  const char *wt_name;
  /**  */
  int raw_freq;
  int source_order;
  /* (٤ε) */
  int cost;
  /*  */
  int feature;
  /** ñ */
  char *word_utf8;
  /** եΥեå */
  int offset;
  /** °yomi_entry*/
  struct yomi_entry* ye;
};

/** ɤ */
struct yomi_entry {
  /* ɤߤʸ */
  xstr *index_xstr;
  /* ɤߤʸ(եΥǥå) */
  char *index_str;
  /* եΥڡΥեå */
  int offset;
  /* ƥȥ */
  int nr_entries;
  struct word_entry *entries;
  /**/
  struct yomi_entry *next;
  struct yomi_entry *hash_next;
};

#define YOMI_HASH (16384 * 16)

/*  */
struct yomi_entry_list {
  /* ФΥꥹ */
  struct yomi_entry *head;
  /* եθФο */
  int nr_entries;
  /* ФñĤΤο */
  int nr_valid_entries;
  /* ñο */
  int nr_words;
  /**/
  struct yomi_entry *hash[YOMI_HASH];
  struct yomi_entry **ye_array;
};

#define ADJUST_FREQ_UP 1
#define ADJUST_FREQ_DOWN 2
#define ADJUST_FREQ_KILL 3

/* ѥޥ */
struct adjust_command {
  int type;
  xstr *yomi;
  const char *wt;
  char *word;
  struct adjust_command *next;
};


/* ξ */
struct mkdic_stat {
  /* ñΥꥹ */
  struct yomi_entry_list yl;
  /**/
  struct adjust_command ac_list;
  /* 㼭 */
  struct uc_dict *ud;
  /**/
  const char *output_fn;
  /**/
  int input_encoding;
  /**/
  int nr_excluded;
  char **excluded_wtypes;
  /**/
  int freq_order;
};

#define INVALID_FREQ 99999
#define MAX_RAW_FREQ 1000

/**/
struct yomi_entry *find_yomi_entry(struct yomi_entry_list *yl,
				   xstr *index, int create);

/* 񤭽ФѤ */
void write_nl(FILE *fp, int i);

/**/
const char *get_wt_name(const char *name);
void push_back_word_entry(struct mkdic_stat *mds,
			  struct yomi_entry *ye, const char *wt_name,
			  int freq, const char *word, int order);
int get_compound_element_len(xchar xc);

/* mkudic.c
 * 㼭 */
struct uc_dict *create_uc_dict(void);
void read_uc_file(struct uc_dict *ud, const char *fn);
void make_ucdict(FILE *out, struct uc_dict *uc);
/**/

/* writewords.c */
void output_word_dict(struct yomi_entry_list *yl);

/* readwords.c */
void read_traditional_dict_file(struct mkdic_stat *mds, const char *fn);
void read_dict_file(struct mkdic_stat *mds, const char *fn);

/* calcfreq.c */
void calc_freq(struct yomi_entry_list *yl);

#endif
